/*
 * File         : testWriteHalo.java
 * Author       : Guansong Zhang
 * Created      : Fri Jan 23 11:23:30 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1998/04/21 21:41:45 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class testWriteHalo {

  static final int n=8;

  public static void main(String argv[]) {
    SpmdEnv spmd = new SpmdEnv(argv);

    Procs2 p=new Procs2(2,2);

    if (p.on()) {

      int [] w = {1,1};
      
      // enum Layout {LAY_STANDARD, LAY_PACKED, LAY_ADAPT, LAY_EXTENDED}

      BlockRange x = new BlockRange (n, p.dim(0), 3, 1, 1);
      BlockRange y = new BlockRange (n, p.dim(1), 3, 1, 1);

      Array2Float u = new Array2Float(x,y, spmd.apg);

      Index i = new Index (x);
      Index j = new Index (y);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  if (i.idx()==0 || i.idx()==n-1 || j.idx()==0 || j.idx()==n-1)
	    u.data[u.element(i, j)]=1;
	  else
	    u.data[u.element(i, j)]=0;
	} j.dim().revo();
      } i.dim().revo();

      Array2Float uold = new Array2Float(x, y, spmd.apg);

      Index ic = new Index (x.subrng(n-2, 1));
      Index jc = new Index (y.subrng(n-2, 1));

      for (int iter=1; iter<=5; iter++) {

	Adlib.copy(uold, u);
	Adlib.writeHalo(uold,w,w);

	ic.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  jc.dim().over();
	  for (jc.begin(); jc.test(); jc.next()) {
	    u.data[u.element(ic,jc)]
	      =(float)0.25*(uold.data[uold.element(ic.shift(-1),jc)]+
			    uold.data[uold.element(ic.shift(1),jc)]+
			    uold.data[uold.element(ic,jc.shift(-1))]+
			    uold.data[uold.element(ic,jc.shift(1))]);
	  } jc.dim().revo();
	} ic.dim().revo();

	Adlib.rprintln("iteration = "+iter);

	Adlib.aprintf("%7.3f%"+n+"N", u);
      }

    } p.no();

    spmd.finalize();
  }
}
